package com.your_domain.your_product.address.dao;

import java.util.ArrayList;
import java.util.Date;

import com.jdbaccess.da.Result;
import com.jdbaccess.da.Transaction;
import com.jdbaccess.dao.DataAccessObjectImpl;
import com.jdbaccess.exception.ApplicationException;
import com.jdbaccess.transfer.TransferObject;
import com.your_domain.your_product.address.transfer.Address;

/**
 * Persistence layer: dao class of entity address 
 */
public class AddressDaoImpl extends DataAccessObjectImpl implements AddressDao {
  private static String ENTITY = Address.getEntityName();
  private static String CREATE_TABLE_STRING = 
    "create table " + ENTITY + 
    " (id int not null auto_increment, street varchar(300), streetnumber varchar(50), zipcode varchar(50), city varchar(300), country varchar(2), creation datetime, modification datetime, primary key(id)) engine = innodb";
  
  public AddressDaoImpl() {
    super();
  }

  public AddressDaoImpl(Transaction t) {
    super(t);
  }

  public void dropTable() throws ApplicationException {
    dropTable(ENTITY);  
  }
  
  public void createTable() throws ApplicationException {
    createTable(CREATE_TABLE_STRING);  
  }
  
  public Address insert(Address adr) throws ApplicationException {
    ArrayList objects = new ArrayList();
    objects.add(adr);
    ArrayList retObjects = (ArrayList)insert(objects);
    return (Address) retObjects.get(0);
  }
  
  public ArrayList insert(ArrayList transferObjects) throws ApplicationException {
    for (int i=0; i<transferObjects.size(); i++) {
      TransferObject to = (TransferObject) transferObjects.get(i);
      to.setEntity(ENTITY);
    }
    return super.insert(transferObjects);
  }

  public Address insert(String street, String streetNumber, String country, String zipCode, String city, Date creation, Date modification) throws ApplicationException {
    Address addr = new Address();
    addr.setValueModified("street", street);
    addr.setValueModified("streetNumber", streetNumber);
    addr.setValueModified("country", country);
    addr.setValueModified("zipCode", zipCode);
    addr.setValueModified("city", city);
    addr.setValueModified("creation", creation);
    addr.setValueModified("modification", modification);
    return insert(addr);
  }
  
  public Long deleteAll() throws ApplicationException {
    return super.deleteAll(ENTITY);
  }
  
  public Result findAll(ArrayList orderBy) throws ApplicationException {
    return findAll(ENTITY, Address.class, orderBy);
  }
  
  public Address findById(Number id) throws ApplicationException {
    return (Address) findByFieldName(ENTITY, "id", id, Address.class);
  }
}
