package com.your_domain.your_product.employee.dao;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;

import com.jdbaccess.da.Result;
import com.jdbaccess.dao.DataAccessObject;
import com.jdbaccess.exception.ApplicationException;
import com.your_domain.your_product.employee.transfer.Employee;

/**
 * persistence layer: dao interface of entity employee 
 */
public interface EmployeeDao extends DataAccessObject {
  public void dropTable() throws ApplicationException;
  public void createTable() throws ApplicationException;
  public void createProceduresAndFunctions() throws ApplicationException;
  public void dropProceduresAndFunctions() throws ApplicationException;
  public Employee insert(Employee dao) throws ApplicationException;
  public ArrayList insert(ArrayList daos) throws ApplicationException;
  public Employee insert(String name, BigDecimal salary, String description, byte[] picture, Date creation, Date modification) throws ApplicationException;
  public Long updateSalaryById(Long id, Number salary) throws ApplicationException;
  public Long deleteAll() throws ApplicationException;
  public Long updateSalaryByName(String name, Number salary) throws ApplicationException;
  public Result findAll(ArrayList orderBy) throws ApplicationException;
  public Employee findById(Long id) throws ApplicationException;
  public Result findByName(String name) throws ApplicationException;
  public Result findBySalaryLessThan(Number salary) throws ApplicationException;
  public ArrayList findAddressesByEmpId(Long empId) throws ApplicationException;
}
