package com.your_domain.your_product.employee.transfer;

import java.math.BigDecimal;
import java.util.Date;

import com.jdbaccess.transfer.TransferObject;

/**
 * transfer object: Employee 
 */
public class Employee extends TransferObject {
  static final long serialVersionUID = Employee.class.hashCode();
  private static String ENTITY_NAME = "employee";
  public Long id;
  public String name;
  public BigDecimal salary;
  public String description;  // long text value
  public byte[] picture;      // long binary value
  public Date creation;
  public Date modification;
  
  public Employee() {
    this.entity = ENTITY_NAME;
  }

  /**
   * @return Returns the picture.
   */
  public byte[] getPicture() {
    return picture;
  }

  /**
   * @param picture The picture to set.
   */
  public void setPicture(byte[] picture) {
    this.picture = picture;
  }

  /**
   * @return Returns the creation.
   */
  public Date getCreation() {
    return creation;
  }

  /**
   * @param creation The creation to set.
   */
  public void setCreation(Date creation) {
    this.creation = creation;
  }

  /**
   * @return Returns the description.
   */
  public String getDescription() {
    return description;
  }

  /**
   * @param description The description to set.
   */
  public void setDescription(String description) {
    this.description = description;
  }

  /**
   * @return Returns the modification.
   */
  public Date getModification() {
    return modification;
  }

  /**
   * @param modification The modification to set.
   */
  public void setModification(Date modification) {
    this.modification = modification;
  }

  /**
   * @return Returns the name.
   */
  public String getName() {
    return name;
  }

  /**
   * @param name The name to set.
   */
  public void setName(String name) {
    this.name = name;
  }

  /**
   * @return Returns the salary.
   */
  public BigDecimal getSalary() {
    return salary;
  }

  /**
   * @param salary The salary to set.
   */
  public void setSalary(BigDecimal salary) {
    this.salary = salary;
  }

  /**
   * @return Returns the id.
   */
  public Long getId() {
    return id;
  }

  /**
   * @param id The id to set.
   */
  public void setId(Long id) {
    this.id = id;
  }

  /**
   * @return Returns the entity name
   */
  public static String getEntityName() {
    return ENTITY_NAME;
  }
}
