package com.your_domain.your_product.employee.transfer;

import java.util.ArrayList;

import com.your_domain.your_product.address.transfer.Address;

/**
 * ValueObject: EmployeeVO 
 * A value object is a complex object which consists of other
 * transfer objects such as Employee or an ArrayList of Address
 */
public class EmployeeVO {
  static final long serialVersionUID = EmployeeVO.class.hashCode();
  private Employee employee;
  private ArrayList addresses; // of type AddressDao; ordering important
  
  public EmployeeVO() {
  }

  public EmployeeVO(Employee emp, ArrayList addresses) {
    this.employee = emp;
    this.addresses = addresses;
  }

  public void addAddress(Address addr) {
    if (addresses == null)
      addresses = new ArrayList();
    addresses.add(addr);
  }

  /**
   * @return Returns the addresses.
   */
  public ArrayList getAddresses() {
    return addresses;
  }

  /**
   * @param addresses The addresses to set.
   */
  public void setAddresses(ArrayList addresses) {
    this.addresses = addresses;
  }

  /**
   * @return Returns the employee.
   */
  public Employee getEmployee() {
    return employee;
  }

  /**
   * @param employee The employee to set.
   */
  public void setEmployee(Employee employee) {
    this.employee = employee;
  }

}
